<?php

add_action('after_setup_theme', 'theme_setup');
function theme_setup() {
    add_theme_support('post-thumbnails');
    add_theme_support('menus');
    // add_theme_support('widgets');
     load_theme_textdomain('ahamh', get_template_directory() . '/languages');
     register_nav_menus(
       array(
         'header_menu' => __('Header Menu', 'ahamh'),
         'footer_menu'=>__('Footer Menu','ahamh'),
         'header_menu_inner' => __('Header Menu Inner', 'ahamh'),
         'footer_menu_inner'=>__('Footer Menu Inner','ahamh'),
         // 'footer_menu2'=>__('Footer Menu2','ahamh'),
       )
     );
}
function wpdocs_theme_name_scripts() {
    wp_enqueue_style( 'style', get_stylesheet_uri() );
}
add_action( 'wp_enqueue_scripts', 'wpdocs_theme_name_scripts' );

/***************************/
// support new uploader
add_action('admin_enqueue_scripts', 'wp_enqueue_media');
add_filter('show_admin_bar', '__return_false');
add_filter('xmlrpc_enabled', '__return_false');
/*****************************/

/***** includes *****/
// require_once('class-wp-bootstrap4-navwalker.php');
// require_once('wp-page-numbers.php');
// require_once('includes/admin/options.php');
// require_once('includes/acf.php');
add_filter('wpcf7_autop_or_not', '__return_false');
/***** language ***/
if (function_exists('icl_get_languages')) {
    function language_selector_flags() {
        $languages = icl_get_languages('skip_missing=0');
        
        // $items = '<span class="navbar-text ml-auto lang-switcher">';                    
        if (!empty($languages)) {     
            $items = '<div class="dropdown">
                <button class="btn dropdown-toggle" type="button" data-toggle="dropdown" aria-expanded="false">
                ';
                foreach ($languages as $key => $l) {  
                    if($l['active']){
                        $items .= '<span>'.strtoupper($l['code']).'</span>';
                    }                
                } 
            $items .= ' 
                    
                    <i class="fas fa-chevron-down"></i>
                </button>
                <div class="dropdown-menu">';
                foreach ($languages as $key => $l) {  
                    if(!$l['active']){
                        $items .= '<a href="'. $l['url'].'" class="dropdown-item">'.strtoupper($l['code']).'</a>';
                    }                
                } 
            $items .= '       
                </div>
            </div>'; 
             
        }
        return $items;
    }
}
if (function_exists('pll_the_languages')) {
    function get_cs_language_switcher() {
        $languages = pll_the_languages( array( 'dropdown' => 1, 'hide_current' => 1, 'raw' => 1 ) );                  
        if (!empty($languages)) {
            foreach ($languages as $key => $l) {  
                if(!$l['current_lang']){
//                    $items = '<li class="nav-item ms-3"><a class="nav-link custom-btn custom-border-btn btn" href="'. $l['url'].'">'.strtoupper($l['name']).'</a></li>';
                    $items = '<li class="nav-item"><a class="nav-link" href="'. $l['url'].'">'.strtoupper($l['name']).'</a></li>';
                }
            }             
        }
        return $items;
    }
}

add_action('init', 'myprefix_remove_tax');
function myprefix_remove_tax() {
    register_taxonomy('category', array());
    register_taxonomy('post_tag', array());
}

function add_additional_class_on_link($atts, $item, $args) {
    if (property_exists($args, 'add_link_class')) {
        $atts['class'] = $args->add_link_class;
    }
    return $atts;
}
function add_additional_class_on_li($classes, $item, $args) {
    // if($args->theme_location == 'footer_menu') {
    //     $classes[] = 'list-inline-item';
    // }
    if(isset($args->add_li_class)) {
//        var_dump($classes);
//        $classes = [];
        $classes[] = $args->add_li_class;
    }
    return $classes;
}
add_filter('nav_menu_css_class', 'add_additional_class_on_li', 1, 3);
add_filter( 'nav_menu_link_attributes', 'add_additional_class_on_link', 1, 3 );


function custom_phone_validation($result,$tag){

    $type = $tag->type;
    $name = $tag->name;

    if($type == 'tel' || $type == 'tel*'){

        $phoneNumber = isset( $_POST[$name] ) ? trim( $_POST[$name] ) : '';

        $phoneNumber = preg_replace('/[() .+-]/', '', $phoneNumber);
            if (strlen((string)$phoneNumber) != 10) {
                $result->invalidate( $tag, 'Please enter a valid phone number.' );
            }
    }
    return $result;
}
// add_filter('wpcf7_validate_tel','custom_phone_validation', 10, 2);
// add_filter('wpcf7_validate_tel*', 'custom_phone_validation', 10, 2);